import type { CodegenOptions } from 'farrow-api/dist/generateApi';
export type ApiClientOptions = {
    /**
     * http address of farrow-api
     */
    src: string;
    /**
     * file address of codegen target
     */
    dist: string;
    /**
     * use alias for farrow-api-client instead of src address
     */
    alias?: string;
    /**
     * codegen options
     */
    codegen?: CodegenOptions;
    /**
     * the interval of polling
     * default value is 3000ms
     */
    pollingInterval?: number;
    /**
     * logger options for polling
     */
    logger?: false | ((options: ApiClientOptions) => void);
    /**
     * transform source code received from server
     * it's useful when need to attach custom code snippet
     */
    transform?: (source: string) => string;
    /**
     * format source code via codegen
     */
    format?: (source: string) => string;
};
export declare const createApiClient: (options: ApiClientOptions) => {
    sync: () => Promise<void>;
    start: () => void;
    stop: () => void;
    build: () => Promise<void>;
};
export type CreateApiClientsOptions = {
    services: ApiClientOptions[];
};
export declare const createApiClients: (options: CreateApiClientsOptions) => {
    sync: () => Promise<void>;
    start: () => void;
    stop: () => void;
    build: () => Promise<void>;
};
